#include <io.h>
#include <inttypes.h>
//#include <avr/eeprom.h>

//------------------------------------------------
// Programme "hello world" pour carte  puce
// 
//------------------------------------------------


// dclaration des fonctions d'entre/sortie dfinies dans "io.c"
void sendbytet0(uint8_t b);
uint8_t recbytet0(void);

// variables globales en static ram
uint8_t cla, ins, p1, p2, p3;	// entte de commande
uint8_t sw1, sw2;		// status word

int taille;		// taille des donnes introduites -- est initialis  0 avant la boucle
#define MAXI 128	// taille maxi des donnes lues
uint8_t data[MAXI];	// donnes introduites

// Procdure qui renvoie l'ATR
void atr(uint8_t n, char* hist)
{
    	sendbytet0(0x3b);	// dfinition du protocole
    	sendbytet0(n);		// nombre d'octets d'historique
    	while(n--)		// Boucle d'envoi des octets d'historique
    	{
        	sendbytet0(*hist++);
    	}
}


// mission de la version
// t est la taille de la chane sv
void version(int t, char* sv)
{
    	int i;
    	// vrification de la taille
    	if (p3!=t)
    	{
        	sw1=0x6c;	// taille incorrecte
        	sw2=t;		// taille attendue
        	return;
    	}
	sendbytet0(ins);	// acquittement
	// mission des donnes
	for(i=0;i<p3;i++)
    	{
        	sendbytet0(sv[i]);
    	}
    	sw1=0x90;
}


// commande de rception de donnes
void intro_data()
{
    	int i;
     	// vrification de la taille
    	if (p3>MAXI)
	{
	   	sw1=0x6c;	// P3 incorrect
        	sw2=MAXI;	// sw2 contient l'information de la taille correcte
		return;
    	}
	sendbytet0(ins);	// acquitement

	for(i=0;i<p3;i++)	// boucle d'envoi du message
	{
	    data[i]=recbytet0();
	}
	taille=p3; 		// mmorisation de la taille des donnes lues
	sw1=0x90;
}


// Programme principal
//--------------------
int main(void)
{
  	// initialisation des ports
	ACSR=0x80;
	PORTB=0xff;
	DDRB=0xff;
	DDRC=0xff;
	DDRD=0;
	PORTC=0xff;
	PORTD=0xff;
	ASSR=(1<<EXCLK)+(1<<AS2);
	//TCCR2A=0;
//	ASSR|=1<<AS2;
	PRR=0x87;


	// ATR
  	atr(11,"Hello scard");

	taille=0;
	sw2=0;		// pour viter de le rpter dans toutes les commandes
  	// boucle de traitement des commandes
  	for(;;)
  	{
    		// lecture de l'entte
    		cla=recbytet0();
    		ins=recbytet0();
    		p1=recbytet0();
	    	p2=recbytet0();
    		p3=recbytet0();
	    	sw2=0;
		switch (cla)
		{
	  	case 0x80:
		    	switch(ins)
			{
			case 0:
				version(4, "1.00");
				break;
		  	case 1:
	        		intro_data();
	        		break;
    		default:
		    		sw1=0x6d; // code erreur ins inconnu
        		}
			break;
      		default:
        		sw1=0x6e; // code erreur classe inconnue
		}
		sendbytet0(sw1); // envoi du status word
		sendbytet0(sw2);
  	}
  	return 0;
}

